﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using SharpOSC;

namespace OSCInterface
{
    
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public string OSCSendIP;
        public Int32 OSCSendPort;

        public int OSCRecivePort;

        public object Assert { get; private set; }

        public MainWindow()
        {
            InitializeComponent();
            OSCSendIP = this.boxOSCSendIP.Text;
            OSCSendPort = Int32.Parse(this.boxOSCSendPort.Text);
            OSCRecivePort = int.Parse(this.boxOSCSRecivePort.Text);
            OSCRecive();

        }

        private void boxOSCSendIP_TextChanged(object sender, TextChangedEventArgs e)
        {
            OSCSendIP = this.boxOSCSendIP.Text;
        }
        private void boxOSCSendPort_TextChanged(object sender, TextChangedEventArgs e)
        {
            OSCSendPort = Int32.Parse(this.boxOSCSendPort.Text);
        }

        private void boxOSCRecivePort_TextChanged(object sender, TextChangedEventArgs e)
        {
            OSCRecivePort = int.Parse(this.boxOSCSRecivePort.Text);
        }

        public void slider_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            OSCSend("/77/28/Y Input Value", this.slider.Value);
        }

        private void comboBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            ComboBoxItem cbitem = (ComboBoxItem)comboBox.SelectedItem;
            OSCSend("/77/5/Input String", cbitem.Content.ToString());
            
        }
        
        public void OSCSend (string adress, object value)
        {

            var sendOSC = new SharpOSC.UDPSender(OSCSendIP, OSCSendPort);
            var msg = new SharpOSC.OscMessage(adress, value);
            sendOSC.Send(msg);
        }

        public void OSCRecive ()
        {
            var listener = new UDPListener(OSCRecivePort);
            var recv = (OscMessage)listener.Receive();

            this.boxOSCSReciveMessage.Text = recv.ToString();



        }

    }
}
