﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using static System.Net.Mime.MediaTypeNames;

namespace OSCInterface
{
    class MouseMoveControl
    {
        private void textBox_MouseMove(object sender, MouseEventArgs e)
        {
            Mouse.OverrideCursor = Cursors.Hand;
            fp_Move_Control(sender, e);
        }

        private void fp_Move_Control(object sender, MouseEventArgs e)
        {
            if (e.LeftButton == MouseButtonState.Pressed)
            {
                if (Mouse.OverrideCursor == Cursors.Hand)
                {
                    TextBox objTextbox = textBox;
                    if (objTextbox != null)
                    {
                        Point mousePoint = e.GetPosition(this);

                        int posY = (int)mousePoint.Y;
                        int actHeight = (int)Application.Current.MainWindow.Height;
                        int margin_Bottom = actHeight - (posY + (int)objTextbox.Height + (int)SystemParameters.CaptionHeight + (int)SystemParameters.BorderWidth + 4);

                        int posX = (int)mousePoint.X;
                        int actWidth = (int)Application.Current.MainWindow.Width;
                        int margin_Right = actWidth - (posX + (int)objTextbox.Width + (int)SystemParameters.BorderWidth);

                        objTextbox.Margin = new Thickness(posX, posY, margin_Right, margin_Bottom);

                        Mouse.OverrideCursor = Cursors.Hand;
                    }
                }
            }
            else
            {
                Mouse.OverrideCursor = Cursors.Arrow;
            }
        }
    }

   
}
